# -*- coding: utf-8 -*-
from __future__ import division 

from thread import *
from datetime import datetime 

import socket, json

class Sender(object):

    def __init__(self, snd_queue, clients):
        super(Sender, self).__init__()
        self.queue = snd_queue
        self.clients = clients
        start_new_thread(self.main, ())

    def main(self):
        while True:
            switches = self.queue.get()

            for client in self.clients:
              start_new_thread( self.send,(client, switches,))

    def send(self, ip_address, switches):
        IP = ip_address
        PORT = 5005
        timeout = 60
        retry = 0

        while True:
            retry += 1
            try:
                sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM) # TCP
                # sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM) # UDP
                sock.settimeout(timeout)
                sock.connect(( IP, PORT ))
                sock.sendall(json.dumps([(c,s) for (c,s,p) in switches]))
                sock.close()
                break
            
            except Exception, e:
                if retry > 5:
                    # notify "ERROR: STA = %s disconnected" % IP
                    break