# -*- coding: utf-8 -*-
from shm import *
from shm_updater import ShmUpdater
from thread import *
from Queue import Queue

import json, sys, socket

shm = Shm()
queue = Queue()
shm_updater = ShmUpdater(shm, queue)

def extract_new_switches((last_channel, last_sw_time), switches):
    for idx, (ch, sw_time) in enumerate(switches):
        if long(sw_time, 16) > long(last_sw_time, 16)
            return switches[idx:]
    return []

#Function for handling connections. This will be used to create threads
def connection_thread(conn, queue, last_switch):
    data = []

    while True:
        string = conn.recv(1024)
        if string:  data.append(string)
        else:  break
    conn.close()

    switches = json.loads("".join(data))
    
    sys.stdout.flush()
    
    if not last_switch:
        # The first time when i don't have nothing in shm
        shm_updater.bootstrap(switches)
        # put in the first element
        last_switch.append(switches[-1])
    else:
        # all the times except the first one
        switches = extract_new_switches(last_switch[0], switches)
        # enqueue all the new received switches
        for (channel, sw_time) in switches:
            queue.put((channel, sw_time))
        # controllo perche magari ho avuto problemi o switches == []
        if switches:
            last_switch[0] = switches[-1]

# ------------------------------------------------
# USAGE:
#    python sta_hbss_algorithm.py 'STA_IP_ADDRESS'
# ------------------------------------------------
IP = sys.argv[1]

PORT = 5005

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) # TCP
# s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM) # UDP
s.bind((IP, PORT))
s.listen(5)

last_switch = []

while True:
  sys.stdout.flush()
  conn, addr = s.accept()
  #start new thread takes 1st argument as a function name to be run, second is the tuple of arguments to the function.
  start_new_thread(connection_thread ,(conn, queue, last_switch))

s.close()
