// Constants for HBSS
#ifndef FH_CONSTANTS_INC
#define FH_CONSTANTS_INC

#define time_now_w3   			[SHM(0xFD0)]
#define time_now_w2   			[SHM(0xFD2)]
#define time_now_w1   			[SHM(0xFD4)]
#define time_now_w0   			[SHM(0xFD6)]
#define time_hop_done_w2		[SHM(0xFD8)]
#define time_hop_done_w1		[SHM(0xFDA)]
#define time_hop_done_w0		[SHM(0xFDC)]

#define access_start_time_w1		[SHM(0xFE0)]
#define access_start_time_w0		[SHM(0xFE2)]

// vars for comparing channels
#define found_satisfying_channel	[SHM(0xFE4)]
#define best_metric_w1 			[SHM(0xFE6)]
#define best_metric_w0			[SHM(0xFE8)]
#define best_channel 			[SHM(0xFEA)]
#define current_channel 		[SHM(0xFEC)]
#define next_channel 			[SHM(0xFEE)]

#define off0_saved 			[SHM(0xFF0)]
#define off1_saved 			[SHM(0xFF2)]
#define last_cs_accu_value		[SHM(0xFF4)]
#define last_cs_accu_value_16ms 	[SHM(0xFF6)]
#define current_round 			[SHM(0xFF8)]

// FLAGS
#define current_row			[SHM(0xFFA)]
#define is_ct_initialized 		[SHM(0xFFC)]
#define is_fh_active			[SHM(0xFFE)]

// Registers
#define switch_time_w0 r48
#define switch_time_w1 r49
#define last_cs_accu_time r62
#define last_cs_accu_time_16ms r56

#define debug r63
#define var1 r59
#define var2 r60
#define var3 r61
#define var4 r46
#define var5 r57
#define var6 r58
#define var7 r50

#define tx_started r53
#define tx_start_time r54
#define rx_started r55
#define access_time_started r47

// Channel table
#define CT_base SHM(0xF10) // SHM(0xB50)
#define CT_entry_size SHM(0x50)
#define CT_eof SHM(0xFB0)

#define CT_index r52

#define CT_off_channel_code 		0
#define CT_off_channel_number 		SHM(0x02)
#define CT_off_is_probe             SHM(0x04)

// WARN: Probably CT_off_switching_time_w3 is USELESS!!
// In the code actually is NOT USED!
#define CT_off_switching_time_w3  	SHM(0x06)
#define CT_off_switching_time_w2 	SHM(0x08)
#define CT_off_switching_time_w1	SHM(0x0A)
#define CT_off_switching_time_w0	SHM(0x0C)

#define CT_off_current_line_dbg		SHM(0x0E)

#define CT_off_time_rx_succ_to_me_w1	SHM(0x10)
#define CT_off_time_rx_succ_to_me_w0	SHM(0x12)
#define CT_off_time_rx_succ_tot_w1	SHM(0x14)
#define CT_off_time_rx_succ_tot_w0	SHM(0x16)
#define CT_off_time_rx_error_w1		SHM(0x18)
#define CT_off_time_rx_error_w0		SHM(0x1A)
#define CT_off_time_tx_w1		SHM(0x1C)
#define CT_off_time_tx_w0		SHM(0x1E)

#define CT_off_count_rx_succ_to_me_w1	SHM(0x20)
#define CT_off_count_rx_succ_to_me_w0	SHM(0x22)
#define CT_off_count_rx_succ_tot_w1	SHM(0x24)
#define CT_off_count_rx_succ_tot_w0	SHM(0x26)
#define CT_off_count_rx_error_w1	SHM(0x28)
#define CT_off_count_rx_error_w0	SHM(0x2A)
#define CT_off_count_tx_succ_w1		SHM(0x2C)
#define CT_off_count_tx_succ_w0		SHM(0x2E)

#define CT_off_count_tx_lost_w1		SHM(0x30)
#define CT_off_count_tx_lost_w0		SHM(0x32)
#define CT_off_access_time_w1		SHM(0x34)
#define CT_off_access_time_w0		SHM(0x36)
#define CT_off_cs_busy_time_w1		SHM(0x38)
#define CT_off_cs_busy_time_w0		SHM(0x3A)
#define CT_off_cs_busy_time_16ms_w1	SHM(0x3C)
#define CT_off_cs_busy_time_16ms_w0	SHM(0x3E)

#define CT_off_rx_bad_plcp_w1		SHM(0x40)
#define CT_off_rx_bad_plcp_w0		SHM(0x42)
#define CT_off_access_time_ma_w1	SHM(0x44)
#define CT_off_access_time_ma_w0	SHM(0x46)

#define CT_off_round_number		SHM(0x48)
#define CT_off_update_count_before	SHM(0x4A)
#define CT_off_update_count_after	SHM(0x4C)

// Live Counters
#define LIVE_COUNTERS_BASE SHM(0xEC0)
	
#define time_rx_succ_to_me_w1		[SHM(0xED0)]
#define time_rx_succ_to_me_w0		[SHM(0xED2)]
#define time_rx_succ_tot_w1		[SHM(0xED4)]
#define time_rx_succ_tot_w0		[SHM(0xED6)]
#define time_rx_error_w1		[SHM(0xED8)]
#define time_rx_error_w0		[SHM(0xEDA)]
#define time_tx_w1			[SHM(0xEDC)]
#define time_tx_w0			[SHM(0xEDE)]

#define count_rx_succ_to_me_w1		[SHM(0xEE0)]
#define count_rx_succ_to_me_w0		[SHM(0xEE2)]
#define count_rx_succ_tot_w1		[SHM(0xEE4)]
#define count_rx_succ_tot_w0		[SHM(0xEE6)]
#define count_rx_error_w1		[SHM(0xEE8)]
#define count_rx_error_w0		[SHM(0xEEA)]
#define count_tx_succ_w1		[SHM(0xEEC)]
#define count_tx_succ_w0		[SHM(0xEEE)]

#define count_tx_lost_w1		[SHM(0xEF0)]
#define count_tx_lost_w0		[SHM(0xEF2)]
#define access_time_w1			[SHM(0xEF4)]
#define access_time_w0			[SHM(0xEF6)]
#define cs_busy_time_w1			[SHM(0xEF8)]
#define cs_busy_time_w0			[SHM(0xEFA)]
#define cs_busy_time_16ms_w1		[SHM(0xEFC)]
#define cs_busy_time_16ms_w0		[SHM(0xEFE)]

#define count_rx_bad_plcp_w1		[SHM(0xF00)]
#define count_rx_bad_plcp_w0		[SHM(0xF02)]
#define access_time_ma_w1		[SHM(0xF04)]
#define access_time_ma_w0		[SHM(0xF06)]

#endif
