// MACROS FOR HBSS
#ifndef FH_MACROS_INC
#define FH_MACROS_INC

#include "fh_constants.inc"

// Useful macro to pass other macros parameters that contain commas
#define SINGLE_ARG(...) __VA_ARGS__

#define OFF0_SET(val) \
	mov	SPR_BASE0, off0_saved \
	mov	val, SPR_BASE0
#define OFF0_RESTORE() \
	mov	off0_saved, SPR_BASE0

#define OFF1_SET(val) \
	mov	SPR_BASE1, off1_saved \
	mov	val, SPR_BASE1
#define OFF1_RESTORE() \
	mov	off1_saved, SPR_BASE1

//#define MUL(val1, val2) \

#define TIME_DIFFERENCE(w0) \
	sub	SPR_TSF_WORD0, w0, w0
	
#define COUNTER_PP(w1, w0) \
	add.	w0, 1, w0 \
	addc	w1, 0, w1

// a += b
#define PLUSEQUAL_32(a1, a0, b1, b0) \
	add.	a0, b0, a0 \
	addc	a1, b1, a1

#define GET_RANDOM_CHANNEL(v) \
random_channel_loop: \
	and	SPR_TSF_Random, 0x000f, v \
	je	v, 0, random_channel_loop- \
	je	v, 15, random_channel_loop-

#define GET_CHANNEL(val) \
	sub val, 0x800c, val 

#endif
